var fs = require('fs');
var request = require('request-promise').defaults({jar: true})

module.exports = {

  isValidFileSize: function(dirname, maxsize) {
    return fs.statSync(dirname)['size'] < maxsize;
  },

  getLengthOfContent: function(string) {
     return Buffer.byteLength(string, 'utf8');
  },

  mkdirIfNotExist: function(dirname) {
    var _dirname = dirname.split('/');
    var parentdir = _dirname.slice(0, _dirname.length-2).join('/');
    if (!fs.existsSync(parentdir)){
      fs.mkdirSync(parentdir);
    }
    if (!fs.existsSync(dirname)){
      fs.mkdirSync(dirname);
    }
  },

  deleteFolderRecursive: function(path) {
    var self = this;
    if( fs.existsSync(path) ) {
      fs.readdirSync(path).forEach(function(file, index){
        var curPath = path + "/" + file;
        if(fs.lstatSync(curPath).isDirectory()) {
          self.deleteFolderRecursive(curPath);
        } else {
          fs.unlinkSync(curPath);
        }
      });
      fs.rmdirSync(path);
    }
  }

};
